diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
index 6f08d6bd5..d5b4f7c59 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block.entity;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
@@ -9,7 +11,9 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
@@ -20,8 +24,18 @@ import java.util.stream.Collectors;
 public class TileEntityMesh extends TileEntity {
     public final @NotNull List<EntityItem> trackedItemsSiphoning = new ArrayList<>(List.of());
     protected final Map<Direction, Boolean> siphonDirValidityCache = new EnumMap<>(Direction.class);
-    protected final int siphonWidth = 5;
-    protected final int siphonHeight = 2;
+    public static final int SIPHON_WIDTH = 5;
+    public static final int SIPHON_HEIGHT = 2;
+    public static final double SIPHON_SPEED = 0.75;
+    protected final int siphonWidth = SIPHON_WIDTH;
+    protected final int siphonHeight = SIPHON_HEIGHT;
+    private final Vector3d siphonVelocity = new Vector3d();
+    private final TilePos pathQueryPos = new TilePos();
+    private static final int REACH_CAPACITY = SIPHON_WIDTH * SIPHON_WIDTH * SIPHON_HEIGHT;
+    private final boolean[] reachableWater = new boolean[REACH_CAPACITY];
+    private final int[] reachQueue = new int[REACH_CAPACITY];
+    private int reachBaseX, reachBaseY, reachBaseZ;
+    private int reachSpanX, reachSpanY, reachSpanZ;
     public int ticksRan = 0;
     public TileEntityMesh() {
     }
@@ -32,88 +46,291 @@ public class TileEntityMesh extends TileEntity {
             return;
         }
 
+        if (ticksRan == 0){
+            ticksRan = worldObj.rand.nextInt(360);
+        }
+        ticksRan++;
+
+        handleSiphon(getSiphonDirection());
+    }
+
+    public @Nullable Direction getSiphonDirection(){
+        if (!isSiphonEnabled()) {
+            return null;
+        }
+
         siphonDirValidityCache.clear();
         for (Direction direction : WireHandler.Directions.ALL) {
             siphonDirValidityCache.put(direction, this.isValidWater(direction));
         }
-        handleSiphon(siphonDirValidityCache);
+        return getSingleValidFace(siphonDirValidityCache);
+    }
 
-        if (ticksRan == 0){
-            ticksRan = worldObj.rand.nextInt(360);
-        }
-        ticksRan++;
+    protected boolean isSiphonEnabled(){
+        return true;
     }
 
     @Override
-    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
-
+    public void invalidate() {
+        super.invalidate();
+        releaseAllTrackedItems();
     }
 
     @Override
-    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {}
 
-    }
+    @Override
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {}
 
-    protected void handleSiphon(@NotNull Map<Direction, Boolean> validSiphonDirections){
+    protected void handleSiphon(@Nullable Direction direction){
         assert this.worldObj != null;
 
-        Direction direction = getSingleValidFace(validSiphonDirections);
-        if(direction == Direction.NONE) { return; }
+        if(direction == null) {
+            releaseAllTrackedItems();
+            return;
+        }
 
         AABBdc siphonBox = getSiphonBox(tilePos, direction);
         List<Entity> entitiesWithinSiphonBox = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, siphonBox);
 
-        if (!this.worldObj.isClientSide) {
-            removeTrackedItems(entitiesWithinSiphonBox);
-        }
+        computeReachableWater(siphonBox, direction);
+        removeTrackedItems(entitiesWithinSiphonBox);
 
         for (Entity entity : entitiesWithinSiphonBox)
         {
             if (entity instanceof EntityItem item && entity.isInWater())
             {
-                if(item.meshSiphoning == null && item.siphonDirection == Direction.NONE){
-                    item.siphonDirection = direction.opposite();
-                    item.meshSiphoning = this;
+                if (!canSiphonItem(item)) continue;
+                if (!canReachItem(item)) continue;
+                if (!tryClaimItem(item, direction)) continue;
+
+                if (!this.worldObj.isClientSide) {
+                    Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
+                    if(player != null) {
+                        player.triggerAchievement(Achievements.DOWN_THE_DRAIN);
+                    }
                 }
+                addItemsToBeTracked(item);
+                siphonItemIntoBlock(item, direction);
+            }
+        }
+    }
 
-                if(direction.opposite().equals(item.siphonDirection) && item.meshSiphoning == this) {
 
-                    if (!this.worldObj.isClientSide) {
-                        Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
-                        if(player != null) {
-                            player.triggerAchievement(Achievements.DOWN_THE_DRAIN);
-                        }
-                        addItemsToBeTracked(item);
-                    }
-                    siphonItemIntoBlock(item, direction);
+    protected boolean canSiphonItem(@NotNull EntityItem item){
+        return true;
+    }
+
+    protected void computeReachableWater(@NotNull AABBdc siphonBox, @NotNull Direction direction){
+        assert this.worldObj != null;
+
+        reachBaseX = MathHelper.floor(siphonBox.minX());
+        reachBaseY = MathHelper.floor(siphonBox.minY());
+        reachBaseZ = MathHelper.floor(siphonBox.minZ());
+        reachSpanX = (int) Math.ceil(siphonBox.maxX()) - reachBaseX;
+        reachSpanY = (int) Math.ceil(siphonBox.maxY()) - reachBaseY;
+        reachSpanZ = (int) Math.ceil(siphonBox.maxZ()) - reachBaseZ;
+
+        Arrays.fill(reachableWater, false);
+
+        int seed = reachIndex(
+            this.tilePos.x + direction.offsetX(),
+            this.tilePos.y + direction.offsetY(),
+            this.tilePos.z + direction.offsetZ()
+        );
+        if (seed < 0) {
+            return;
+        }
+
+        reachableWater[seed] = true;
+        int head = 0;
+        int tail = 0;
+        reachQueue[tail++] = seed;
+
+        while (head < tail) {
+            int index = reachQueue[head++];
+
+            int x = reachBaseX + (index / reachSpanZ) / reachSpanY;
+            int y = reachBaseY + (index / reachSpanZ) % reachSpanY;
+            int z = reachBaseZ + index % reachSpanZ;
+
+            for (Direction step : WireHandler.Directions.ALL) {
+                int nextX = x + step.offsetX();
+                int nextY = y + step.offsetY();
+                int nextZ = z + step.offsetZ();
+
+                if (!movesAwayFromMesh(x, y, z, nextX, nextY, nextZ)) {
+                    continue;
+                }
+
+                int neighbour = reachIndex(nextX, nextY, nextZ);
+                if (neighbour < 0 || reachableWater[neighbour]) {
+                    continue;
                 }
+
+                if (this.worldObj.getBlockMaterial(pathQueryPos.set(nextX, nextY, nextZ)) != Materials.WATER) {
+                    continue;
+                }
+
+                reachableWater[neighbour] = true;
+                reachQueue[tail++] = neighbour;
+            }
+        }
+    }
+
+    private boolean movesAwayFromMesh(int x, int y, int z, int nextX, int nextY, int nextZ){
+        if (nextX != x) return Math.abs(nextX - this.tilePos.x) > Math.abs(x - this.tilePos.x);
+        if (nextY != y) return Math.abs(nextY - this.tilePos.y) > Math.abs(y - this.tilePos.y);
+        return Math.abs(nextZ - this.tilePos.z) > Math.abs(z - this.tilePos.z);
+    }
+
+    private int reachIndex(int x, int y, int z){
+        int localX = x - reachBaseX;
+        int localY = y - reachBaseY;
+        int localZ = z - reachBaseZ;
+
+        if (localX < 0 || localY < 0 || localZ < 0
+            || localX >= reachSpanX || localY >= reachSpanY || localZ >= reachSpanZ) {
+            return -1;
+        }
+
+        return (localX * reachSpanY + localY) * reachSpanZ + localZ;
+    }
+
+    protected boolean canReachItem(@NotNull EntityItem item){
+        return isInReachableWater(item) && hasLineOfSightTo(item);
+    }
+
+    protected boolean hasLineOfSightTo(@NotNull EntityItem item){
+        if (this.worldObj == null) {
+            return false;
+        }
+
+        final double originX = item.x;
+        final double originY = item.y;
+        final double originZ = item.z;
+
+        final double dx = (this.tilePos.x + 0.5) - originX;
+        final double dy = (this.tilePos.y + 0.5) - originY;
+        final double dz = (this.tilePos.z + 0.5) - originZ;
+
+        int x = MathHelper.floor(originX);
+        int y = MathHelper.floor(originY);
+        int z = MathHelper.floor(originZ);
+
+        final int stepX = dx > 0 ? 1 : (dx < 0 ? -1 : 0);
+        final int stepY = dy > 0 ? 1 : (dy < 0 ? -1 : 0);
+        final int stepZ = dz > 0 ? 1 : (dz < 0 ? -1 : 0);
+
+        final double tDeltaX = stepX == 0 ? Double.MAX_VALUE : Math.abs(1.0 / dx);
+        final double tDeltaY = stepY == 0 ? Double.MAX_VALUE : Math.abs(1.0 / dy);
+        final double tDeltaZ = stepZ == 0 ? Double.MAX_VALUE : Math.abs(1.0 / dz);
+
+        double tMaxX = stepX == 0 ? Double.MAX_VALUE : (stepX > 0 ? (x + 1 - originX) : (originX - x)) * tDeltaX;
+        double tMaxY = stepY == 0 ? Double.MAX_VALUE : (stepY > 0 ? (y + 1 - originY) : (originY - y)) * tDeltaY;
+        double tMaxZ = stepZ == 0 ? Double.MAX_VALUE : (stepZ > 0 ? (z + 1 - originZ) : (originZ - z)) * tDeltaZ;
+
+        int guard = 4 * (SIPHON_WIDTH + SIPHON_HEIGHT);
+        while (!(x == this.tilePos.x && y == this.tilePos.y && z == this.tilePos.z)) {
+            if (guard-- <= 0) {
+                return false;
+            }
+
+            if (tMaxX < tMaxY && tMaxX < tMaxZ) {
+                x += stepX;
+                tMaxX += tDeltaX;
+            } else if (tMaxY < tMaxZ) {
+                y += stepY;
+                tMaxY += tDeltaY;
+            } else {
+                z += stepZ;
+                tMaxZ += tDeltaZ;
+            }
+
+            if (x == this.tilePos.x && y == this.tilePos.y && z == this.tilePos.z) {
+                break;
+            }
+
+            if (this.worldObj.getBlockMaterial(pathQueryPos.set(x, y, z)) != Materials.WATER) {
+                return false;
             }
         }
+
+        return true;
+    }
+
+    protected boolean isInReachableWater(@NotNull EntityItem item){
+        int index = reachIndex(MathHelper.floor(item.x), MathHelper.floor(item.y), MathHelper.floor(item.z));
+        if (index >= 0 && reachableWater[index]) {
+            return true;
+        }
+
+        int below = reachIndex(MathHelper.floor(item.x), MathHelper.floor(item.y - 0.25), MathHelper.floor(item.z));
+        return below >= 0 && reachableWater[below];
+    }
+
+
+    protected boolean tryClaimItem(@NotNull EntityItem item, @NotNull Direction direction){
+        TileEntityMesh currentOwner = item.meshSiphoning;
+
+        if (currentOwner == this) {
+            item.siphonDirection = direction.opposite();
+            return true;
+        }
+
+        if (currentOwner != null && !currentOwner.isInvalid() && currentOwner.worldObj == this.worldObj) {
+            double ownerDist = currentOwner.getDistanceFrom(item.x, item.y, item.z);
+            if (ownerDist <= this.getDistanceFrom(item.x, item.y, item.z)) {
+                return false;
+            }
+            currentOwner.releaseItem(item);
+        }
+
+        item.meshSiphoning = this;
+        item.siphonDirection = direction.opposite();
+        return true;
     }
 
     protected void removeTrackedItems(@NotNull List<Entity> entitiesWithinSiphonBox){
         Iterator<EntityItem> iterator = trackedItemsSiphoning.iterator();
         while (iterator.hasNext()) {
             EntityItem item = iterator.next();
-            if (!entitiesWithinSiphonBox.contains(item)) {
-                item.siphonDirection = Direction.NONE;
-                item.meshSiphoning = null;
+            if (item.removed || !canSiphonItem(item) || !canReachItem(item) || !entitiesWithinSiphonBox.contains(item)) {
+                clearOwnership(item);
                 iterator.remove();
-                break;
             }
         }
     }
 
+    protected void releaseAllTrackedItems(){
+        for (EntityItem item : trackedItemsSiphoning) {
+            clearOwnership(item);
+        }
+        trackedItemsSiphoning.clear();
+    }
+
+    protected void releaseItem(@NotNull EntityItem item){
+        trackedItemsSiphoning.remove(item);
+        clearOwnership(item);
+    }
+
+    private void clearOwnership(@NotNull EntityItem item){
+        if (item.meshSiphoning == this) {
+            item.meshSiphoning = null;
+            item.siphonDirection = null;
+        }
+    }
+
     protected void addItemsToBeTracked(@NotNull EntityItem item){
         if(!trackedItemsSiphoning.contains(item))
             trackedItemsSiphoning.add((item));
     }
 
-    protected @NotNull Direction getSingleValidFace(@NotNull Map<Direction, Boolean> validSiphonDirections){
-        //If none are valid or if more than one side is valid, returns Direction.NONE
+    protected @Nullable Direction getSingleValidFace(@NotNull Map<Direction, Boolean> validSiphonDirections){
+        //If none are valid or if more than one side is valid, returns null
         //else, returns the valid Direction
 
-        Direction direction = Direction.NONE;
+        Direction direction = null;
 
         int amountTrue = 0;
         for (boolean value : validSiphonDirections.values()) {
@@ -135,7 +352,7 @@ public class TileEntityMesh extends TileEntity {
         }
 
         if (direction == Direction.DOWN){
-            return Direction.NONE;
+            return null;
         }
 
         return direction;
@@ -188,79 +405,105 @@ public class TileEntityMesh extends TileEntity {
         return new AABBd(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
+    // Deterministic item noise so that the items agree between client and server
+    protected static double itemNoise(@NotNull EntityItem item, int salt){
+        int h = item.id * 0x9E3779B9 + salt * 0x85EBCA6B;
+        h ^= h >>> 15;
+        h *= 0x2545F491;
+        h ^= h >>> 13;
+        return (h >>> 8) / (double)(1 << 24);
+    }
+
     protected void siphonItemIntoBlock(@NotNull EntityItem item, @NotNull Direction direction){
 
-        double targetX = this.tilePos.x + 0.5;
-        double targetY = this.tilePos.y + 0.5;
-        double targetZ = this.tilePos.z + 0.5;
+        double wanderPhase = itemNoise(item, 1) * Math.PI * 2.0;
+        double swirlJitter = 0.8 + itemNoise(item, 3) * 0.4;
+        double pullJitter  = 0.85 + itemNoise(item, 4) * 0.3;
+        double wander      = Math.sin(item.age * 0.15 + wanderPhase) * 0.1;
+
+        computeSiphonVelocity(this.tilePos, direction, item.x, item.y, item.z,
+                wander, swirlJitter, pullJitter, this.siphonVelocity);
+
+        item.xd = this.siphonVelocity.x;
+        item.yd = this.siphonVelocity.y;
+        item.zd = this.siphonVelocity.z;
+    }
+
+    public static @NotNull Vector3d computeSiphonVelocity(
+            @NotNull TilePosc meshPos, @NotNull Direction direction,
+            double x, double y, double z,
+            double wander, double swirlJitter, double pullJitter,
+            @NotNull Vector3d out
+    ){
+        double targetX = meshPos.x() + 0.5 + (direction.axis() == Axis.X ? 0.0 : wander);
+        double targetY = meshPos.y() + 0.5 + (direction.axis() == Axis.Y ? 0.0 : wander * 0.5);
+        double targetZ = meshPos.z() + 0.5 + (direction.axis() == Axis.Z ? 0.0 : -wander);
 
         //difference vectors
-        double diffX = targetX - item.x;
-        double diffY = targetY - item.y;
-        double diffZ = targetZ - item.z;
+        double diffX = targetX - x;
+        double diffY = targetY - y;
+        double diffZ = targetZ - z;
 
-        //distance from item
+        //distance from the mesh
         double dist = Math.sqrt(diffX * diffX + diffY * diffY + diffZ * diffZ);
 
         //we don't divide by zero in this household
-        if (dist > 0.01) {
-
-            //Siphon variables yippee!!!!
-            double maxRange         = Math.max(siphonWidth / 2.0, siphonHeight);
-            double clampedDist      = Math.min(dist, maxRange);
-            double proximityFactor  = 1.0 + (maxRange / (clampedDist + 0.5));
-            double pullStrength     = 0.05;
-            double dynSwirlStrength = (pullStrength * 1.5) * proximityFactor;
-
-            /*
-            //normalize the pull speed and apply the dynamic speed multiplier
-            double pullX = (diffX / dist) * speedMultiplier;
-            double pullY = (diffY / dist) * speedMultiplier;
-            double pullZ = (diffZ / dist) * speedMultiplier;
-            */
-
-            //non-normalize implementation
-            double speedMultiplier  = pullStrength * proximityFactor;
-            double pullX = diffX  * speedMultiplier;
-            double pullY = diffY  * speedMultiplier;
-            double pullZ = diffZ  * speedMultiplier;
-
-            //axis check to make sure the swirl behaves correctly depending on facing direction
-            double sX = 0, sY = 0, sZ = 0;
-            if (direction.axis() == Axis.Y) {
-                sX = -diffZ;
-                sZ = diffX;
-            } else if (direction.axis() == Axis.Z) {
-                sX = -diffY;
-                sY = diffX;
-            } else {
-                sY = -diffZ;
-                sZ = diffY;
-            }
+        if (dist <= 0.01) {
+            return out.set(0.0, 0.0, 0.0);
+        }
 
-            double swirlDist = Math.sqrt(sX * sX + sY * sY + sZ * sZ);
-            if (swirlDist > 0.01) {
-                // swirl also gets faster as it gets closer
-                sX = (sX / swirlDist) * dynSwirlStrength;
-                sY = (sY / swirlDist) * dynSwirlStrength;
-                sZ = (sZ / swirlDist) * dynSwirlStrength;
-            }
+        //Siphon variables yippee!!!!
+        double maxRange         = Math.max(SIPHON_WIDTH / 2.0, SIPHON_HEIGHT);
+        double clampedDist      = Math.min(dist, maxRange);
+        double proximityFactor  = 1.0 + (maxRange / (clampedDist + 0.5));
+        double pullStrength     = 0.05 * pullJitter;
+        double swirlFade        = Math.min(1.0, dist / 0.75);
+        double dynSwirlStrength = (pullStrength * 1.5) * proximityFactor * swirlJitter * swirlFade;
+
+        double speedMultiplier  = pullStrength * proximityFactor;
+
+        double lateralBoost = 3.0;
+        double pullX = diffX * speedMultiplier * (direction.axis() == Axis.X ? 1.0 : lateralBoost);
+        double pullY = diffY * speedMultiplier * (direction.axis() == Axis.Y ? 1.0 : lateralBoost);
+        double pullZ = diffZ * speedMultiplier * (direction.axis() == Axis.Z ? 1.0 : lateralBoost);
+
+        //axis check to make sure the swirl behaves correctly depending on facing direction
+        double sX = 0, sY = 0, sZ = 0;
+        if (direction.axis() == Axis.Y) {
+            sX = -diffZ;
+            sZ = diffX;
+        } else if (direction.axis() == Axis.Z) {
+            sX = -diffY;
+            sY = diffX;
+        } else {
+            sY = -diffZ;
+            sZ = diffY;
+        }
 
-            item.xd = pullX + sX;
-            item.yd = pullY + sY;
-            item.zd = pullZ + sZ;
-
-            //kinda gave up here, don't know what I was on but it kinda works so..?
-            double slowStrength = 0.5 - (0.2 * (1.0 - (clampedDist / maxRange)));
-            switch (direction) {
-                case UP    -> {if (item.yd < 0) item.yd *= slowStrength;}
-                case DOWN  -> {if (item.yd > 0) item.yd *= slowStrength;}
-                case NORTH -> {if (item.zd > 0) item.zd *= slowStrength;}
-                case SOUTH -> {if (item.zd < 0) item.zd *= slowStrength;}
-                case WEST  -> {if (item.xd > 0) item.xd *= slowStrength;}
-                case EAST  -> {if (item.xd < 0) item.xd *= slowStrength;}
-            }
+        double swirlDist = Math.sqrt(sX * sX + sY * sY + sZ * sZ);
+        if (swirlDist > 0.01) {
+            // swirl also gets faster as it gets closer
+            sX = (sX / swirlDist) * dynSwirlStrength;
+            sY = (sY / swirlDist) * dynSwirlStrength;
+            sZ = (sZ / swirlDist) * dynSwirlStrength;
+        } else {
+            sX = sY = sZ = 0;
         }
+
+        out.set(pullX + sX, pullY + sY, pullZ + sZ);
+
+        //kinda gave up here, don't know what I was on but it kinda works so..?
+        double slowStrength = 0.5 - (0.2 * (1.0 - (clampedDist / maxRange)));
+        switch (direction) {
+            case UP    -> {if (out.y < 0) out.y *= slowStrength;}
+            case DOWN  -> {if (out.y > 0) out.y *= slowStrength;}
+            case NORTH -> {if (out.z > 0) out.z *= slowStrength;}
+            case SOUTH -> {if (out.z < 0) out.z *= slowStrength;}
+            case WEST  -> {if (out.x > 0) out.x *= slowStrength;}
+            case EAST  -> {if (out.x < 0) out.x *= slowStrength;}
+        }
+
+        return out.mul(SIPHON_SPEED);
     }
 
     protected boolean isValidWater(@NotNull Direction direction){
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 1680d12e8..afcaa9081 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -1,51 +1,44 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.tags.CompoundTag;
-import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.current.wire.WireHandler;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.primitives.AABBdc;
-
-import java.util.Arrays;
-import java.util.List;
-import java.util.Map;
-import java.util.stream.Collectors;
 
 public class TileEntityMeshGold extends TileEntityMesh {
     @Nullable
     public ItemStack filterItem;
-    public int ticksRan = 0;
+
     public TileEntityMeshGold() {
     }
 
     @Override
     public void tick()
     {
-        if (this.worldObj == null || this.worldObj.isClientSide) {
+        if (this.worldObj == null) {
             return;
         }
 
-        if(filterItem != null){
-            siphonDirValidityCache.clear();
-            for (Direction direction : WireHandler.Directions.ALL) {
-                siphonDirValidityCache.put(direction, this.isValidWater(direction));
-            }
-            handleSiphon(siphonDirValidityCache);
-        }
-
         if (ticksRan == 0){
             ticksRan = worldObj.rand.nextInt(360);
         }
         ticksRan++;
+
+        if (this.worldObj.isClientSide) {
+            return;
+        }
+
+        handleSiphon(getSiphonDirection());
+    }
+
+    @Override
+    protected boolean isSiphonEnabled(){
+        return this.filterItem != null;
     }
 
     @Override
@@ -97,39 +90,11 @@ public class TileEntityMeshGold extends TileEntityMesh {
     }
 
     @Override
-    protected void handleSiphon(@NotNull Map<Direction, Boolean> validSiphonDirections){
-        //null-checks were already made
-        assert this.worldObj != null;
-        assert this.filterItem != null;
-
-        Direction direction = getSingleValidFace(validSiphonDirections);
-        if(direction == Direction.NONE){return;}
-        AABBdc siphonBox = getSiphonBox(tilePos, direction);
-        List<Entity> entitiesWithinSiphonBox = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, siphonBox);
-        removeTrackedItems(entitiesWithinSiphonBox);
-
-        for (Entity entity : entitiesWithinSiphonBox)
-        {
-            if (entity instanceof EntityItem item && entity.isInWater())
-            {
-                if(item.meshSiphoning == null && item.siphonDirection == Direction.NONE){
-                    item.siphonDirection = direction.opposite();
-                    item.meshSiphoning = this;
-                }
-                if(direction.opposite() == item.siphonDirection && item.meshSiphoning == this) {
-                    if (item.item.getItem() == this.filterItem.getItem() && item.item.getMetadata() == this.filterItem.getMetadata()) {
-
-                        Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
-                        if(player != null) {
-                            player.triggerAchievement(Achievements.DOWN_THE_DRAIN);
-                        }
-
-                        siphonItemIntoBlock(item, direction);
-                        addItemsToBeTracked(item);
-                    }
-                }
-            }
-        }
+    protected boolean canSiphonItem(@NotNull EntityItem item){
+        return this.filterItem != null
+            && item.item != null
+            && item.item.getItem() == this.filterItem.getItem()
+            && item.item.getMetadata() == this.filterItem.getMetadata();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java
index 5cc1a36ee..371cc2092 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java
@@ -25,7 +25,9 @@ public class RecipeCraftingShapedJsonAdapter implements RecipeJsonAdapter<Recipe
         ItemStack result = context.deserialize(obj.get("result").getAsJsonObject(),ItemStack.class);
         boolean consumeContainers = obj.has("consumeContainers") ? obj.get("consumeContainers").getAsBoolean() : DEFAULT_CONSUME_CONTAINER;
         boolean mirror = obj.has("mirror") ? obj.get("mirror").getAsBoolean() : DEFAULT_ALLOW_MIRROR;
-        return RecipeRegistry.parseRecipe(pattern, symbols, result, consumeContainers, mirror);
+        RecipeEntryCraftingShaped recipe = RecipeRegistry.parseRecipe(pattern, symbols, result, consumeContainers, mirror);
+        if (obj.has("group")) recipe.consolidationGroup = obj.get("group").getAsString();
+        return recipe;
     }
 
     @Override
@@ -75,6 +77,9 @@ public class RecipeCraftingShapedJsonAdapter implements RecipeJsonAdapter<Recipe
         if (src.allowMirrored != DEFAULT_ALLOW_MIRROR) {
             obj.addProperty("mirror",src.allowMirrored);
         }
+        if (src.consolidationGroup != null) {
+            obj.addProperty("group", src.consolidationGroup);
+        }
         return obj;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapelessJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapelessJsonAdapter.java
index a70c1008c..005400415 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapelessJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapelessJsonAdapter.java
@@ -16,7 +16,9 @@ public class RecipeCraftingShapelessJsonAdapter implements RecipeJsonAdapter<Rec
         JsonObject obj = json.getAsJsonObject();
         List<RecipeSymbol> symbols = obj.get("inputs").getAsJsonArray().asList().stream().map((E)->context.<RecipeSymbol>deserialize(E,RecipeSymbol.class)).collect(Collectors.toList());
         ItemStack result = context.deserialize(obj.get("result").getAsJsonObject(),ItemStack.class);
-        return new RecipeEntryCraftingShapeless(symbols,result);
+        RecipeEntryCraftingShapeless recipe = new RecipeEntryCraftingShapeless(symbols,result);
+        if (obj.has("group")) recipe.consolidationGroup = obj.get("group").getAsString();
+        return recipe;
     }
 
     @Override
@@ -27,6 +29,9 @@ public class RecipeCraftingShapelessJsonAdapter implements RecipeJsonAdapter<Rec
         List<RecipeSymbol> symbols = src.getInput();
         obj.add("inputs",context.serialize(symbols));
         obj.add("result",context.serialize(src.getOutput()));
+        if (src.consolidationGroup != null) {
+            obj.addProperty("group", src.consolidationGroup);
+        }
         return obj;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
index c8796b640..e8b816128 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
@@ -8,6 +8,8 @@ import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
 public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void> {
 
+    public String consolidationGroup = null;
+
     public RecipeEntryCrafting(I input, O output) {
         super(input, output, null);
     }
